[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.1 and 1.57

version 1.1, 2021/09/30 04:06:56 version 1.57, 2021/12/08 03:45:05
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset
         # no bsort for now  
         sed -n "$1" /var/run/dmesg.boot  CFILE=SHA256.sig
   DESTDIR=${DESTDIR:-}
   FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
   
   VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
   HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   tmpdir() {
           local _i=1 _dir
   
           # If we're not in the installer,
           # we have mktemp and a more hostile environment
           if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
           echo "$_dir"
 }  }
   
 installed_firmware() {  realpath () {
         for fw in ${PKGDIR}/$1-firmware*; do          if [ -x /usr/bin/realpath ]; then
                 [ -e "$fw" ] || continue                  /usr/bin/realpath "$1"
                 echo ${fw##*/}          elif [ "$1" = "${1%/*}" ]; then
                   echo "${PWD}/$1"
           else
                   echo "$( cd "${1%/*}" && pwd )/${1##*/}"
           fi
   }
   
   fetch() {
           local _file=$1 _user=_file _exit
   
           >"$_file"
           chown "$_user" "$_file"
   
           # If we're not in the installer, we have su(1)
           # and doas(1) is unlikely to be configured.
           if [ -x /usr/bin/su ]; then
                   /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm \
                           -o '$_file' '${FWURL}/${_file}'"
                   _exit="$?"
           else
                   /usr/bin/doas -u "$_user" \
                       ftp -D 'Get/Verify' -Vm \
                           -o "$_file" "${FWURL}/${_file}"
                   _exit="$?"
           fi
   
           if [ "$_exit" -ne 0 ]; then
                   rm -f "$_file"
                   echo "Cannot fetch $_file" >&2
                   return 1
           fi
   
           chown root "$_file"
   }
   
   verify() {
           # On the installer we don't get sha256 -C, so fake it.
           if ! fgrep -qx "SHA256 ($1) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for $1 failed." >&2
                   return 1
           fi
   }
   
   devices_needing_firmware() {
           local _d _m _grep _dmesgtail _last=''
   
           # When we're not in the installer, the dmesg.boot can
           # contain multiple boots, so only look in the last one
           _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
   
           grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   _grep="grep"
                   [ "$_last" = "$_d" ] && continue
                   [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                   [ "$_m" = "${_m#^}" ] && _grep="fgrep"
   
                   echo "$_dmesgtail" | $_grep -q "$_m" || continue
                   echo "$_d"
                   _last="$_d"
         done          done
 }  }
   
 set -A _KERNV -- $( scan_dmesg '/^OpenBSD \([1-9][0-9]*\.[0-9]\)\([^ ]*\) .*/ { s//\1 \2/p; q; }' )  firmware_filename() {
 VNAME=${_KERNV[0]}          local _f
 OSDIR=$VNAME          _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
 if ((${#_KERNV[*]} > 1)) && [ "$_KERNV[1]" = "-current" -o "$_KERNV[1]" = "-beta" ]; then          ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
         OSDIR=snapshots          echo "$_f"
 fi  }
   
 FWURL=http://firmware.openbsd.org/firmware/${OSDIR}  firmware_devicename() {
 PKGDIR=${DESTDIR}/var/db/pkg          local _d="${1##*/}"
 PATTERNS="file:${0%/*}/firmware_patterns"          _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 drivers=$(  installed_firmware() {
         last=''          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
         ftp -D "Detecting" -Vmo- $PATTERNS |                  [ -e "$fw" ] || continue
         while read d m; do                  echo "${fw##*/}"
                 [ "$last" = "$d" ] && continue  
                 [ "$m" ] || m="^$d[0-9][0-9]* at "  
                 [ "$( scan_dmesg "/$m/ { p; q; }" )" ] || continue  
                 echo $d  
                 last=$d  
         done          done
 )  }
   
 if [ -z "$drivers" ]; then  add_firmware () {
         echo "No devices found which need firmware files to be downloaded." >&2          local _f="$1" _pkgdir="${DESTDIR}/var/db/pkg"
         exit 0          ftp -D "Install" -Vmo- "file:${1}" |
 fi                  tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
                   -s ",^firmware,${DESTDIR}/etc/firmware," \
                   -C / -zxphf - "+*" "firmware/*"
   
 tmpdir=${DESTDIR}/tmp/fw_update          # TODO: Should we mark these so real fw_update can -Drepair?
 [ -e "$tmpdir" ] && rm -rf "$tmpdir"          ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
 mkdir -p "$tmpdir"  /^@comment pkgpath/ -1a
 cd "$tmpdir"  @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 # TODO: Drop privs during fetch and verify  delete_firmware() {
 ftp -D Get -Vm "$FWURL/SHA256.sig"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
 # Probably should bundle the firmware sigfile on the installer,          # TODO: Check hash for files before deleting
 # although we can just get it from the recently installed system.          echo "Uninstalling $_pkg"
 if [ "$DESTDIR" ]; then          _cwd="${_pkgdir}/$_pkg"
         sigfile=$( sed -n '/^untrusted comment: verify with \(.*\)$/ { s//\1/p; q; }' SHA256.sig )  
         if [ ! -e "/etc/signify/$sigfile" ] \  
           && [ -e "${DESTDIR}/etc/signify/$sigfile" ]; then  
                 cp -a "${DESTDIR}/etc/signify/$sigfile" "/etc/signify/$sigfile"  
         fi  
 fi  
   
 signify -Ve -x SHA256.sig -m - < SHA256.sig > SHA256          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
 for d in $drivers; do          while read -r c g; do
         firmware=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" SHA256 )                  case $c in
         installed=$( installed_firmware $d )                  @cwd) _cwd="${DESTDIR}$g"
                     ;;
                   @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
         for i in $installed; do          # We specifically rm -f here because not removing files/dirs
                 if [ "$firmware" = "$i.tgz" ]; then          # is probably not worth failing over.
                         echo "Firmware for $d already installed ($installed)"          for _r in "${_remove[@]}" ; do
                         continue 2                  if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                   else
                           rm -f "$_r"
                 fi                  fi
         done          done
   }
   
         mkdir $d  set -A devices -- $( devices_needing_firmware )
   
         # TODO: Drop privs during fetch and verify  if [ ! "${devices:-}" ]; then
         ftp -D "Get/Verify" -Vmo- "$FWURL/$firmware" | sha256 -bph "$d/h" > "$firmware"          echo "No devices found which need firmware files to be downloaded."
         fgrep -qx "SHA256 ($firmware) = $(<$d/h)" SHA256          exit
   fi
   
         # TODO: Check hash for files before deleting  TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then  cd "$TMPDIR"
                 echo "Uninstalling $installed"  
                 cwd=${PKGDIR}/$installed  
   
                 remove="${cwd}/+CONTENTS ${cwd}"  # To unpriv we need to let the unpriv user into this dir
   chmod go+x .
   
                 while read c g; do  fetch "$CFILE"
                         case $c in  ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                         @cwd) cwd=$g      echo "Signature check of SHA256.sig failed" >&2 && exit 1
                           ;;  
                         @*) continue  
                           ;;  
                         *)  remove="$cwd/$c $remove"  
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do  for d in "${devices[@]}"; do
                         if [ -d "$r" ]; then          f=$( firmware_filename "$d" || true )
                                 # Try hard not to actually remove recursively          [ "$f" ] || continue
                                 # without rmdir on the install media.          set -A installed -- $( installed_firmware "$d" )
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"  
                         else          if [ "${installed:-}" ]; then
                                 rm -f "$r"                  for i in "${installed[@]:-}"; do
                           if [ "$f" = "$i.tgz" ]; then
                                   echo "$i already installed"
                                   continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          fetch  "$f" || continue
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall          verify "$f" || continue
         echo "Installing $firmware"  
         tar -zxphf "$firmware" -C /etc "firmware/*"          if [ "${installed:-}" ]; then
         mkdir -p ${PKGDIR}/${firmware%.tgz}/                  for i in "${installed[@]}"; do
         tar -zxphf "$firmware" -C "${PKGDIR}/${firmware%.tgz}" "+*"                          delete_firmware "$i"
     ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL                  done
 /^@comment pkgpath/ -1a          fi
 @option manual-installation  
 @option firmware          add_firmware "$f"
 @comment install-script  
 .  
 w  
 EOL  
 done  done
   

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.57

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>